#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Jan 10 14:33:33 2018

@author: boiboite
"""

"----------------------------------------------------------------------------"
"--------Exercice 1 Question 2.a. - Sujet juin 2013 Polynésie série S--------"
"------------------------ Aire totale des 4 grands rectangles ---------------"
"Traduction 'mot pour mot' de l'algorithme de l'énoncé"
"Toutes les valeurs du problème étant fixées, procédons par lignes de commandes"

"Soit la fonction f, positive et strictement décroissante sur [0 ; 1],"
"définie sur R par"
from math import exp
def f(x):
    return((x + 2) * exp(-x))

"Calcul de la somme des aires des 4 grands rectangles"
S = 0
for k in range(4):
    S = S + 1 / 4 * f(k / 4)
print("S = ", S)


"---------------------------------------------------------------------------"
"------ Exercice 1 Question 2.b. - Sujet juin 2013 Polynésie série S -------"
"------------------ Aire totale des N grands rectangles --------------------"
"Le nombre d'intervalles est N qui devient un paramètre de l'algorithme."
"Il faut donc calculer les valeurs des N + 1 bornes des intervalles"
"Dans un premier temps elles seront calculées dans une boucle type 2.a."

"Soit la fonction f, positive et strictement décroissante sur [0 ; 1],"
"    définie sur R par"
from math import exp
def f(x):
    return((x + 2) * exp(-x))

"Calcul de la somme des aires des N grands rectangles."
N = 20
S = 0
for k in range(N):
    S = S + 1 / N * f(k / N)
print("S = ", S)

"La même chose sous forme d'une fonction de paramètre N, c'est plus 'pratique'."
"Utilise la fonction f positive et strictement décroissante sur [0 ; 1]."
def aireGR(N = 4):






"------------------------------ PROLONGEMENT 1 ------------------------------"
"------------ Représentation graphique des 4 grands rectangles --------------"
"----------------- + Aire totale des 4 grands rectangles --------------------"
"Et si l'on veut faire la représentation graphique des 4 grands rectangles ?"
"Il faut calculer les valeurs des coordonnées des 4 sommets."
"    de chacun des 4 rectangles."

"Soit la fonction f, positive et strictement décroissante sur [0 ; 1],"
"    définie sur R par"
from math import exp
def f(x):
    return((x + 2) * exp(-x))

"Pour tracer la portion de la courbe de f sur [0 ; 1]."
"Je crée le tuple des abscisses et le tuple des ordonnées de quelques points."
"Entre ces point la commande plot(...) 'complètera' le tracé."
tupleX = (0, 1/4, 2/4, 3/4, 4/4)
tupleY = tuple((f(i) for i in tupleX))
tuple(round(tupleY[i], 2) for i in range(4))

"Pour tracer les 4 grands rectangles, il faut 'passer' par les coordonnées"
"     des 4 sommets de chacun des 4 rectangles :"
"     pour une valeur de X il y a 2 valeurs de Y : 0 et f(X)"
"C'est la commande plt.fill(...) qui trace les rectangles avec comme arguments"
"    le tuple des abscisses et le tuple des ordonnées des sommets de chaque rectangle."
"J'en profite pour faire calculer et afficher la surface totale"
"    des 4 grands rectangles."
import matplotlib.pyplot as plt
airetotGran = 0
plt.figure()
plt.plot(tupleX, tupleY, 'r-')
for i in range(4):
    plt.fill((tupleX[i], tupleX[i], tupleX[i + 1], tupleX[i + 1]),
             (0, tupleY[i], tupleY[i], 0),
             alpha = 0.5, fill = False, hatch = '//', color = 'green')
    airetotGran = airetotGran + (1/4 * tupleY[i])
plt.title('Aire grands rectangles = ' + str(round(airetotGran, 4)))
plt.xlabel('X')
plt.ylabel('f(X)')
plt.grid()
plt.axis('equal')
plt.show()


"------------------------------ PROLONGEMENT 2 ------------------------------"
"------------ Représentation graphique des N grands rectangles --------------"
"----------------- + Aire totale des N grands rectangles --------------------"
"Et si l'on veut faire la représentation graphique des N grands rectangles ?"
"Il faut calculer les valeurs des coordonnées des 4 sommets"
"    de chacun des N rectangles."

"Soit la fonction f, positive et strictement décroissante sur [0 ; 1],"
"définie sur R par :"
from math import exp
def f(x):
    return((x + 2) * exp(-x))

"Pour tracer la portion de la courbe de f sur [0 ; 1]."
"Je crée le tuple des abscisses et le tuple des ordonnées de quelques points."
"Entre ces point la commande plot(...) 'complètera' le tracé."
N = 20
tupleX = tuple(i/N for i in range(N + 1))
tupleX[0:7]

tupleY = tuple(f(i) for i in tupleX)
tupleY[0:7]

"Pour tracer les N grands rectangles, il faut 'passer' par les coordonnées"
"     des 4 sommets de chacun des N grands rectangles :"
"     pour une valeur de X il y a 2 valeurs de Y : 0 et f(X)"
"C'est la commande plt.fill(...) qui trace les rectangle et les 'décore'."
"J'en profite pour faire calculer et afficher la surface totale"
"    des N grands rectangles"
import matplotlib.pyplot as plt
airetotGran = 0
plt.figure()
plt.plot(tupleX, tupleY, 'r-')
for i in range(N):
    plt.fill((tupleX[i], tupleX[i], tupleX[i + 1], tupleX[i + 1]),
             (0, tupleY[i], tupleY[i], 0),
             alpha = 0.5, fill = False, hatch = '//', color = 'green')
    airetotGran = airetotGran + (1/N * tupleY[i])
plt.title('Aire grands rectangles = ' + str(round(airetotGran, 4)))
plt.xlabel('X')
plt.ylabel('f(X)')
plt.grid()
plt.axis('equal')
plt.show()


"-------------------------"
"Une fonction correspondante."
"Utilise la fonction f."
from math import exp
def f(x):
    return((x + 2) * exp(-x))

def aireGRN01(N = 4):
    import matplotlib.pyplot as plt











    plt.xlabel('X')
    plt.ylabel('f(X)')
    plt.grid()
    plt.axis('equal')
    plt.show()


"------------------------------ PROLONGEMENT 3 ------------------------------"
"----- Exercice 1 Question 2.b.+ - Sujet juin 2013 Polynésie série S ------"
"-------- Et si l'on travaillait maintenant sur un intervalle [a ; b] -------"
"    sur lequel la fonction est positive et strictement DÉCROISSANTE."
"---------------------"
"----- Calcul de la surface totale des N GRANDS RECTANGLES --"
from math import exp
def f(x):
    return((x + 2) * exp(-x))

N = 5 ; a = 0 ; b = 2
pas = (b - a) / N
S = 0
for k in range(N):
    S = S + pas * f(a + k * pas)
print("S = ", S)


"---------------------"
"-- On fait afficher l'aire de chacun des N GRANDS RECTANGLES"
"     puis l'aire totale"
from math import exp
def f(x):
    return((x + 2) * exp(-x))

N = 8 ; a = 1 ; b = 3










"---------------------"
"- Représentation graphique et surface totale, des N GRANDS RECTANGLES -"
from math import exp
import matplotlib.pyplot as plt

def f(x):
    return((x + 2) * exp(-x))

N = 5 ; a = 0 ; b = 2
pas = (b - a) / N
pas
tupleX = tuple(a + pas * i for i in range(N + 1))
tupleX
tupleY = tuple(f(i) for i in tupleX)
tupleY

airetotGran = 0
plt.figure()
plt.plot(tupleX, tupleY, 'r-')
for i in range(N):
    plt.fill((tupleX[i], tupleX[i], tupleX[i + 1], tupleX[i + 1]),
             (0, tupleY[i], tupleY[i], 0),
             alpha = 0.5, fill = False, hatch = '//', color = 'green')
    airetotGran = airetotGran + (pas * tupleY[i])
plt.title('Aire grands rectangles = ' + str(round(airetotGran, 4)))
plt.xlabel('X')
plt.ylabel('f(X)')
plt.grid()
plt.axis('equal')
plt.show()


"---------------------"
"--- Une fonction correspondante pour les N GRANDS RECTANGLES ---"
"Utilise la fonction f positive, strictement DÉCROISSANTE."
from math import exp
def f(x):
    return((x + 2) * exp(-x))

def aireGRNab(N = 5, a = 0, b = 2):
    import matplotlib.pyplot as plt












    plt.xlabel('X')
    plt.ylabel('f(X)')
    plt.grid()
    plt.axis('equal')
    plt.show()


"------------------------------ PROLONGEMENT 4 ------------------------------"
"-- Représentation graphique et surface totale des N PETITS RECTANGLES --"
"Définition de la fonction utilisée :"
"Elle doit être positive et strictement DÉCROISSANTE sur"
"    l'intervalle d'intégration [a ; b]"
"f est définie sur R par"
from math import exp
def f(x):
    return((x + 2) * exp(-x))

def airePRNab(N = 4, a = 0, b = 1):
    import matplotlib.pyplot as plt
    pas = (b - a) / N
    tupleX = tuple(a + pas * i for i in range(N + 1))
    tupleY = tuple(f(i) for i in tupleX)
    airetotPetit = 0
    plt.figure()
    plt.plot(tupleX, tupleY, 'r-')
    for i in range(N):




    plt.title('Aire petits rectangles = ' + str(round(airetotPetit, 4)))
    plt.xlabel('X')
    plt.ylabel('f(X)')
    plt.grid()
    plt.axis('equal')
    plt.show()



"----------------------------------------------------------------------------"
"------------------------------ PROLONGEMENT 5 ------------------------------"
"------- Exercice 1 Question 2 ++  Sujet juin 2013 Polynésie série S --------"
"---------- N GRANDS RECTANGLES et N PETITS RECTANGLES sur [a ; b] ----------"
"------ fonction positive et strictement décroissante sur [a ; b] -----------"
"Utilise les array (listes) de numpy à la place des tuples (moins de ressource)" 

"f est définie sur R par"
from math import exp
def f(x):
    return((x + 2) * exp(-x))

"L'intégration est à faire sur l'intervalle  I = [a ; b]"
"N intervalles de même longueur sont définis par N + 1 bornes équidistantes"
"On génère, entre 0 et 1, nb nombres équidistants, stockés dans listeX, un nbarray"
from numpy import linspace
a = 0 ; b = 1 ; N = 4
listeX = linspace(a, b, N + 1, endpoint = True)
listeX

"Calcul de la nbarray des images de listeX par f"
listeY = [f(i) for i in listeX]
listeY

"On juxtapose deux graphiques horizontalement"
import matplotlib.pyplot as plt
airetotGran = 0 ; pas = (b - a) / N
plt.figure()
plt.subplot(1, 2, 1)
plt.plot(listeX, listeY, 'r-')
plt.xlim(a, b)
for i in range(N):
    plt.fill((listeX[i], listeX[i], listeX[i + 1], listeX[i + 1]),
             (0, listeY[i], listeY[i], 0),
             alpha = 0.5, fill = False, hatch = '//', color = 'green')
    airetotGran += (pas * listeY[i])
plt.title('Aire g.rectangles = ' + str(round(airetotGran, 4)))
plt.axis('equal')
plt.grid()
airetotPeti = 0
plt.subplot(1, 2, 2)
plt.plot(listeX, listeY, 'r-')
plt.xlim(a, b)
for i in range(N):
    plt.fill((listeX[i], listeX[i], listeX[i + 1], listeX[i + 1]),
             (0, listeY[i + 1], listeY[i + 1], 0),
             alpha = 0.5, fill = False, hatch = '//', color = 'blue')
    airetotPeti += (pas * listeY[i + 1])
plt.title('Aire p.rectangles = ' + str(round(airetotPeti, 4)))
plt.axis('equal')
plt.grid()
plt.show()


"----------------------------------------------------------------"
"Une fonction correspondante"
"Définition de la fonction utilisée"
"Elle doit être positive et strictement DÉCROISSANTE sur [a ; b]"
"f est définie sur R par"
from math import exp
def f(x):
    return((x + 2) * exp(-x))

def darbDecrois(N = 10, a = 0, b = 1):
    from numpy import linspace
    import matplotlib.pyplot as plt









    for i in range(N):










    for i in range(N):




 

    plt.grid()
    plt.show()


"----------------------------------------------------------------------------"
"------------------------------ PROLONGEMENT 6 ------------------------------"
"----- Exercice 1 Question 2 +++ - Sujet juin 2013 Polynésie série S --------"
"------ N = nb - 1 GRANDS RECTANGLES et N PETITS RECTANGLES sur [a ; b] -----"
"------ fonction positive et strictement croissante sur [a ; b] -------------"

"f est définie sur R par"
from math import exp
def f(x):
    return((x + 2) * exp(x))

def darbCrois(N = 10, a = -1, b = 0):
    from numpy import linspace
    import matplotlib.pyplot as plt
    listeX = linspace(a, b, N + 1, endpoint = True)
    listeY = [f(i) for i in listeX]
    pas = (b - a) / N
    airetotGran = 0
    airetotPeti = 0
    plt.figure()
    plt.subplot(1, 2, 1)
    plt.plot(listeX, listeY, 'r-')
    plt.xlim(a, b)
    for i in range(N):




    plt.title('Aire p.rectangles = ' + str(round(airetotGran, 4)))
    plt.axis('equal')
    plt.grid()
    plt.subplot(1, 2, 2)
    plt.plot(listeX, listeY, 'r-')
    plt.xlim(a, b)
    for i in range(N):




    plt.title('Aire g.rectangles = ' + str(round(airetotPeti, 4)))
    plt.axis('equal')
    plt.grid()
    plt.show()


